/**
  VGA Graphic Demo with Parallax VGA_512x384_Bitmap Interface
  
  for DemoBoard Wiring
  
  reimay / January 2012
	
*/

#include <stdio.h>
#include <string.h>
#include <propeller.h>                   
////////////////////////////////////////////////////////////////////////
//  Mailbox
////////////////////////////////////////////////////////////////////////
static unsigned int sync; 
static unsigned int reg_dira;
static unsigned int reg_vcfg;
static unsigned int * pixel_ptr;
static unsigned short * color_ptr;

static unsigned int y_sample;

////////////////////////////////////////////////////////////////////////
unsigned int   PIXEL_BUFFER[6144];
unsigned short COLOR_BUFFER[192];
////////////////////////////////////////////////////////////////////////
void msleep(int t)
{
    waitcnt((CLKFREQ/1000)*t+CNT);
}

////////////////////////////////////////////////////////////////////////
void plot( unsigned int x, unsigned int y)
{

	int tmp = x % 32;

	if(x >= 0 && x < 512 && y >= 0 && y < 384)
	{
	  PIXEL_BUFFER[(x/32) + (y*16)] |=  1<<tmp; 
	}
}
////////////////////////////////////////////////////////////////////////
int start(unsigned int *ptr)  
{
    extern unsigned int binary_vga_dat_start[];
    return cognew(&binary_vga_dat_start, ptr);
}

int start2(unsigned int *ptr)  
{
    extern unsigned int binary_mic_dat_start[];
    return cognew(&binary_mic_dat_start, ptr);
}
////////////////////////////////////////////////////////////////////////

void main (void)
{
  unsigned int x,c,i;
	
	// Preset the mailbox parameters

  sync = 0;
	
	reg_dira = 0x00FF0000;
	
	reg_vcfg = 0x200000FF + (16 << 6);  

  // Fill Color Buffer
    
	for(i = 0; i < 192; i++)
	{
		COLOR_BUFFER[i] = 0xFF00 ;
	}
	
    pixel_ptr = PIXEL_BUFFER;
	color_ptr = COLOR_BUFFER;

	// start the vga Driver
	start(&sync);
	// start the mic driver
	start2(&y_sample);

/*
  Graphic Demo :
  

*/
	while(1)
	{
 	  for(x = 0;x < 512;x++)
 	  {
		plot(x,192 + (y_sample>>25) );
		if(sync) // HOW TO CLEAR THE SCREEN ?
	    {
	      for(i=0;i<192;i++)COLOR_BUFFER[i] = 0x0000 ;
		  for(i=0;i<192;i++)COLOR_BUFFER[i] = 0xFF00 ;
		  sync = 0;
	    }		
		
 	  }

	}
 
}
////////////////////////////////////////////////////////////////////////

